Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 88702 - Multiple SYN/ACK when receiving traffic from MS Win2kPro SP3 client
Multiple SYN/ACK when receiving traffic from MS Win2kPro SP3 client
Status: CLOSED NOTABUG
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
7.3
i386 Linux
medium Severity high
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-04-11 21:30 EDT by John Hardin
Modified: 2007-04-18 12:53 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-04-11 22:01:34 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
tcpdump traces of multiple SYN/ACK failed MyODBC connection tests from W2kPro SP3 to Linux server (2.71 KB, text/plain)
2003-04-11 21:37 EDT, John Hardin
no flags Details
Detailed trace of failed connection (5.20 KB, text/plain)
2003-04-11 21:48 EDT, John Hardin
no flags Details

  None (edit)
Description John Hardin 2003-04-11 21:30:06 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.0) Gecko/20020606

Description of problem:
Win2k Pro SP3 + hotfixes (as of 4/11/2003) clients cause odd TCP behavior which
can lead to slow connections and/or session failure.

Synopsis: 
  W2kProSP3 sends SYN packet
  Linux sends SYN/ACK
  W2kProSP3 sends ACK
  Linux sends second SYN/ACK
  W2kProSP3 ACKs again
  ...data exchange...
  Odd FIN/RST behavior ends session

The behavior of the client varies from long initial delays (e.g. telnet)  to
consistent failure (MyODBC).

Win2kPro SP2 and WinXPProSP1 DO NOT display this behavior. The initial SYN
packet only gets one SYN/ACK response.

Version-Release number of selected component (if applicable):
kernel-2.4.18-24.7.xsmp

How reproducible:
Sometimes

Steps to Reproduce:
1. Create Win2kPro SP3 and apply all critical updates from Windows Update
2. Install MySQL 4.0.1 on server, MyODBC on client, and configure a connection
3. Run tcpdump
4. Telnet to server
5. Test ODBC connection
    

Actual Results:  
   Telnet trace shows multiple SYN/ACK, long delay before login prompt.

   MySQL trace shows multiple SYN/ACK and ODBC test succeeds after long delay,
or fails with "Lost connection to MySQL server during query".


Expected Results:  
   Quick telnet login prompt, only one SYN/ACK in trace.
   Quick success on ODBC test, only one SYN/ACK in trace.

Additional info:

Worst systems are developer desktops: Delphi 6, possible .NET dev env.
Comment 1 John Hardin 2003-04-11 21:37:49 EDT
Created attachment 91093 [details]
tcpdump traces of multiple SYN/ACK failed MyODBC connection tests from W2kPro SP3 to Linux server
Comment 2 John Hardin 2003-04-11 21:38:28 EDT
Problem also reported to MySQL bug mailing list.

Comment 3 John Hardin 2003-04-11 21:48:40 EDT
Created attachment 91094 [details]
Detailed trace of failed connection

{grumble} Is SP3 generating bogus TCP checksums, then choking on the
retransmitted data?
Comment 4 John Hardin 2003-04-11 22:01:34 EDT
Okay, found it. SP3 was offloading the TCP checksum calculation to the network
card, and not doing it properly. Turning off TX checksum offloading fixed the
problem.

It's bad that Win2k choked on the retransmitted packets, though...


Note You need to log in before you can comment on or make changes to this bug.